"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FloatingTextBox = void 0;
const react_1 = __importStar(require("react"));
const s = __importStar(require("../styles"));
const FloatingTextBox = ({ helpText, label, name, value, ...rest }) => {
    const textboxId = name + "Textbox";
    const [inputStyle, setInputStyle] = (0, react_1.useState)(s.FormFloatingFormControl);
    const [labelStyle, setLabelStyle] = (0, react_1.useState)(s.FloatingLabel);
    (0, react_1.useEffect)(() => {
        if (value) {
            setLabelStyle(s.FloatingLabelFocus);
        }
    }, []);
    const thisFocus = (e) => {
        setInputStyle({
            ...s.FormControlFocus,
            ...s.FormFloatingFormControl,
        });
        setLabelStyle(s.FloatingLabelFocus);
    };
    const thisBlur = (e) => {
        if (!e.target.value || e.target.value.length === 0) {
            setLabelStyle(s.FloatingLabel);
        }
        setInputStyle(s.FormFloatingFormControl);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { style: s.FormFloating },
            react_1.default.createElement("input", { style: inputStyle, id: textboxId, name: name, onFocus: (e) => { e.target.select(); thisFocus(e); }, onBlur: (e) => { thisBlur(e); }, value: value, ...rest }),
            react_1.default.createElement("label", { style: labelStyle, htmlFor: textboxId }, label)),
        (helpText && helpText.length > 0)
            ? react_1.default.createElement("div", { style: { fontSize: '.875em', marginTop: '0.25rem', opacity: '0.7' } }, helpText)
            : null));
};
exports.FloatingTextBox = FloatingTextBox;
//# sourceMappingURL=textbox.js.map